;-----------------------------------------------------------------------------
;             873FRJM.ASM le 29/12/2012 Testeur Jouefmatic 
;
	LIST		P=PIC16F873		; Dfinition du processeur
	#include	<p16F873.inc>	; Dfinitions des variables
	__CONFIG   _CP_OFF & _DEBUG_OFF & _WRT_ENABLE_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _PWRTE_ON & _WDT_OFF & _HS_OSC
;	P16F873 =  "_WRT_ENABLE_OFF",   P16F873A = "_WRT_OFF"
	ERRORLEVEL  -302
;-----------------------------------------------------------------------------
BANK0	macro				; passer en banque0
	bcf	STATUS,RP0
	endm
BANK1	macro				; passer en banque1
	bsf	STATUS,RP0
	endm
;-----------------------------------------------------------------------------
	CBLOCK	0x20	;    Dbut de la zone variables
	numrou	; Numro fourni par les roues codeuses = 00  16.
	numcal	; Numro du canal Jouefmatif.
	var_02	; Unit + dixime de Hertz (cod BCD).
	var_03	; Dizaine de Hertz         (cod BCD).
	compt0
	compt1
	numca2	; Numro de canal 1  16 dans le cadre du balayage.
	w_temp	; Sauvegarde registre W
	status_temp	; sauvegarde registre STATUS
	ENDC

;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------

	ORG     0		; 1 -> Dmarrage  la mise sous tension
	goto    debut
	ORG     4		; 2 -> En cas d'interruption
	goto    inter
	dt "___JOUEFMATIC_V1___"	; Texte visible dans le .hex dans ICPROG

;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
debut call	init			; Initialise le PIC, les variables et les interruptions.
boucl	movfw  PORTB		; Lecture des roues codeuses du n de canal, roue des units.
	xorlw  B'11111111'	; Inverse la valeur des bits lus (contact actif=mis  la masse).
	andlw	 B'00001111'	; On garde les 4 bits de droite.
	movwf	 numrou
	movlw	 .10
	btfss	 PORTB,4		; Lecture de la roue codeuse des dizaine = bit RB(4).
	addwf	 numrou,f		; numrou = numrou + 10   si RB(4) = 0.

	movf   numrou,w		; test si numrou =< 19
	sublw  .19  
	nop
	btfsc  STATUS,C
	goto   valok
	movlw  .19
	movwf  numrou


valok	movlw	 0			; numrou = 00 = 19 = Numro fourni par les roues codeuses.
	subwf  numrou,w		; Si 00 => balayage de tous les canaux.
	btfss  STATUS,Z
	goto   fixe_xx		; Le numro fourni par les roues codeuses est <> 0  => goto 'fixe_xx'.

	movf   numca2,w		; test si numca2 =< 16
	sublw  .16  
	nop
	btfsc  STATUS,C
	goto   va2ok
	movlw  .16
	movwf  numca2

va2ok	movf   numca2,w
	movwf  numcal
	movlw  .2
	movwf  PCLATH
	movf   numcal,w
	call   tableau1_lsb	; index -> W
	movwf	 var_02

	movlw  .2
	movwf  PCLATH
	movf   numcal,w
	call   tableau1_msb	; index -> W
	movwf  var_03

	movf	 var_02,w	; lsb
	movwf	 PORTC
	movf	 var_03,w	; msb
	movwf	 PORTA
	goto   boucl


;
; Cas ou l'on est sur un seul canal fixe.
; On peut aussi demander un dcalage en frquence pour vrifier que si l'on augmente ou diminue
; la frquence du canal affich, on diminue le niveau du vumtre.
;
; numrou = Numro de canal => Transform en Khz=> va_03, var_03 (Dizaine, unit + dixime)

fixe_xx
	btfsc	 PORTB,6		; Lecture de l'interrupteur F = Fn + 1%
	goto   pas02		; Interrupteur  off = goto -> pas02.
	movlw  .3
	movwf  PCLATH
	movf   numrou,w
	call   tableau2p_lsb	; index -> W, Tableau +1% dans l'ordre des n de canaux.
	movwf	 var_02
	movlw  .3
	movwf  PCLATH
	movf   numrou,w
	call   tableau2p_msb	; index -> W
	movwf  var_03
	goto   pas06

pas02	btfsc	 PORTB,7		; Lecture de l'interrupteur F = Fn - 1%
	goto   pas04		; Interrupteur  off = goto -> pas04.
	movlw  .3
	movwf  PCLATH
	movf   numrou,w
	call   tableau2m_lsb	; index -> W, Tableau -1% dans l'ordre des n de canaux.
	movwf	 var_02
	movlw  .3
	movwf  PCLATH
	movf   numrou,w
	call   tableau2m_msb	; index -> W
	movwf  var_03
	goto   pas06

pas04	movlw  .2
	movwf  PCLATH
	movf   numrou,w		; Donc pas de dcalage de frquence.
	call   tableau2_lsb	; index -> W, Tableau dans l'ordre des n de canaux.
	movwf	 var_02
	movlw  .2
	movwf  PCLATH
	movf   numrou,w
	call   tableau2_msb	; index -> W
	movwf  var_03

pas06	movf	 var_02,w	; lsb
	movwf	 PORTC
	movf	 var_03,w	; msb
	movwf	 PORTA
	goto   boucl
;
;-----------------------------------------------------------------------------
; PAR ORDRE DE FREQUENCES
; Tableau des frquences cod en BDC (Binaire cod dcimal).
;-----------------------------------------------------------------------------
; Table1 : 1  16 = numro de canal metteur Jouefmatic dans l'ordre des fquences
repere1
	ORG 0x200			; adresse du tableau
tableau1_msb
	addwf PCL , f	; ajouter w  PCL 
	retlw	00		; Frquences directement en Khz. Dizaine de Kilohertz
	retlw	05		; Commence  01 = 54,5 Khz
	retlw	05		; PAR ORDRE DE FREQUENCES
	retlw	06
	retlw	07
	retlw	08
	retlw	08
	retlw	09
	retlw	10
	retlw	11
	retlw	12
	retlw	13
	retlw	14
	retlw	16
	retlw	18
	retlw	19
	retlw	21		; Fini en 16
tableau1_lsb
	addwf PCL , f   ; ajouter w  PCL 
	retlw	00		; Frquences directement en Khz. Unit et dixime de Kilohertz
	retlw	45		; Commence  01 = 54,5 Khz
	retlw	94		; PAR ORDRE DE FREQUENCES
	retlw	48
	retlw	07
	retlw	03
	retlw	76
	retlw	56
	retlw	43
	retlw	38
	retlw	42
	retlw	55
	retlw	78
	retlw	78
	retlw	31
	retlw	97
	retlw	79		; Fini en 16

;-----------------------------------------------------------------------------
; PAR ORDRE DES CANAUX
;-----------------------------------------------------------------------------
; Table2 : 1  16 = numro metteur Jouefmatic dans l'ordre des numros des canaux
repere2
tableau2_msb
	addwf PCL , f   ; ajouter w  PCL 
	retlw	00		; Frquences directement en Khz. Dizaine de Kilohertz
	retlw	13		; Commence  01 = 135,5 Khz
	retlw	11		; PAR ORDRE DES CANAUX
	retlw	09
	retlw	08
	retlw	14
	retlw	12
	retlw	10
	retlw	08
	retlw	07
	retlw	06
	retlw	05
	retlw	05
	retlw	16
	retlw	18
	retlw	19
	retlw	21		; Fini en 16
	retlw	10		; 100 Khz  150 Khz et 200 Khz pour essais
	retlw	15	
	retlw	20
tableau2_lsb
	addwf PCL , f   ; ajouter w  PCL 
	retlw	00		; Frquences directement en Khz. Unit et dixime de Kilohertz
	retlw	55		; Commence  01 = = 135,5 Khz
	retlw	38		; PAR ORDRE DES CANAUX
	retlw	56
	retlw	03
	retlw	78
	retlw	42
	retlw	43
	retlw	76
	retlw	07
	retlw	48
	retlw	94
	retlw	45
	retlw	78
	retlw	31
	retlw	97
	retlw	79		; Fini en 16 +1%
	retlw	00
	retlw	00
	retlw	00

;-----------------------------------------------------------------------------
; PAR ORDRE DES CANAUX (F = Fn + 1%)
;-----------------------------------------------------------------------------
; Table2p : 1  16 = numro metteur Jouefmatic dans l'ordre des numros des canaux (+1% en frquence)
repere2p
	ORG 0x300			; adresse du tableau
tableau2p_msb
	addwf PCL , f   ; ajouter w  PCL 
	retlw	00		; Frquences directement en Khz. Dizaine de Kilohertz
	retlw	13		; Commence  01 = 135,5 Khz + 1%
	retlw	11		; PAR ORDRE DES CANAUX (F=Fn + 1%)
	retlw	09
	retlw	08
	retlw	14
	retlw	12
	retlw	10
	retlw	08
	retlw	07
	retlw	06
	retlw	05
	retlw	05
	retlw	16
	retlw	18
	retlw	20
	retlw	22		; Fini en 16 +1%
	retlw	10		; 100 Khz  150 Khz et 200 Khz pour essais
	retlw	15	
	retlw	20
tableau2p_lsb
	addwf PCL , f   ; ajouter w  PCL 
	retlw	00		; Frquences directement en Khz. Unit et dixime de Kilohertz
	retlw	68		; Commence  01 Khz
	retlw	49		; PAR ORDRE DES CANAUX (F=Fn + 1%)
	retlw	65
	retlw	11
	retlw	92
	retlw	54
	retlw	53
	retlw	84
	retlw	14
	retlw	54
	retlw	99
	retlw	50
	retlw	94
	retlw	49
	retlw	16
	retlw	00		; Fini en 16 + 1%
	retlw	00
	retlw	00
	retlw	00

;-----------------------------------------------------------------------------
; PAR ORDRE DES CANAUX (F = Fn - 1%)
;-----------------------------------------------------------------------------
; Table2m : 1  16 = numro metteur Jouefmatic dans l'ordre des numros des canaux (-1% en frquence).
repere2m
tableau2m_msb
	addwf PCL , f   ; ajouter w  PCL 
	retlw	00		; Frquences directement en Khz. Dizaine de Kilohertz
	retlw	13		; Commence  01 = 135,5 Khz - 1%
	retlw	11		; PAR ORDRE DES CANAUX (F=Fn - 1%)
	retlw	09
	retlw	07
	retlw	14
	retlw	12
	retlw	10
	retlw	08
	retlw	06
	retlw	06
	retlw	05
	retlw	05
	retlw	16
	retlw	18
	retlw	19
	retlw	21		; Fini en 16 -1%
	retlw	10		; 100 Khz  150 Khz et 200 Khz pour essais
	retlw	15	
	retlw	20
tableau2m_lsb
	addwf PCL , f   ; ajouter w  PCL 
	retlw	00		; Frquences directement en Khz. Unit et dixime de Kilohertz
	retlw	41		; Commence  01 = 135,5 Khz - 1%
	retlw	26		; PAR ORDRE DES CANAUX (F=Fn - 1%)
	retlw	46
	retlw	94
	retlw	63
	retlw	29
	retlw	32
	retlw	67
	retlw	99
	retlw	41
	retlw	88
	retlw	39
	retlw	61
	retlw	12
	retlw	77
	retlw	57		; Fini en 16 -1%
	retlw	00
	retlw	00
	retlw	00

;-----------------------------------------------------------------------------
; Routine d'interruption pour traiter le timer 2 pour faire du 100 Hertz en B(5)
;-----------------------------------------------------------------------------
inter	; 
	movwf   w_temp 		; sauver registre W
	swapf   STATUS,w		; swap status avec rsultat dans w
	movwf   status_temp	; sauver status swapp

	incfsz  compt0,f		; dcrmenter compteur et tester sa valeur
	goto	  inte3		; compteur = 0, ne pas traiter la boucle
	movlw   B'00100000'
	xorwf   PORTB,f		; Inverse la sortie RB5 pour sortir un signal  100 hertz

	movlw   .252		; .252 => compte 252, 253, 254, 255 pour diviser par 4 le timer. 
	movwf   compt0
inte3 bcf     PIR1,TMR2IF	; effacer flag interupt tmr2

	incf    compt1,f		; 'compt1' pour un compteur pour le balayage des n de canaux.
	incf    compt1,f
	movlw  0   
	subwf  compt1,w
	btfsc  STATUS,Z
	incf   numca2,f

	movlw  .17			; 'numca2' = Numro du canal de 1  16 pour balayage.
	subwf  numca2,w
	btfss  STATUS,Z
	goto   inte5
	movlw  .1
	movwf  numca2

inte5 nop



;restaurer registres
	swapf   status_temp,w 	; swap ancien status, rsultat dans w
	movwf   STATUS 		; restaurer status
	swapf   w_temp,f 		; Inversion L et H de l'ancien W ; sans modifier Z
	swapf   w_temp,w 		; Rinversion de L et H dans W	; W restaur sans modifier status
	retfie ;

;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
init	; Routine d'initialisation
	clrf    PORTB		; initialisation de toutes les sorties  0
	clrf    PORTA
	clrf    PORTC

	BANK1				; passer en banque1
	movlw   B'00000000'	; PORTA sortie (RA5-RA0)
	movwf   TRISA
	movlw   B'11011111'	; PORTB RB0  RB4 en entre, RB5 en sortie
	movwf   TRISB
	movlw   B'00000000'	; PORTC en sortie (RC7-RC0)
	movwf   TRISC
	BANK0				; passer en banque0

	movlw   1
	movwf   numrou
	movwf   numca2

; initialiser Timer 1 = OFF
; -------------------
;   nc  nc  = 00 = Pas utilis
;   T1CKPS  = 11 = Prdiviseur du Timer1 = 8,
;   T1OSCEN =  0 = Oscillateur interne  off
;   T1SYN   =  0 = Pas utile si TMR1ON = 1
;   TMR1CS  =  0 = Source prdiviseur = Fosc/4/T1CKPS
;   TMR1ON  =  0 = Le timer est  l'arrt
	movlw   B'00110000'
	movwf   T1CON		; Bank0

;   nc  nc  = 00 = pas utilis
;   CCP1XY  = xx = bit lsb de CCPR1L
;   CCP1M   = 0000 = module compare => mode PMW)
;	movlw   B'00000000'
;	movwf   CCP1CON		; Bank0


; initialiser Timer 2 = ON
; -------------------
;   nc      =   0 => Pas utilis
;   TOUTPS  = 1111=> Prdiviseur du Timer2 = 16
;   T2OSCEN =   0 => Oscillateur interne  off = 0
;   TMR2ON  =   1 => TMR2ON = 1 = ON
;   TMR2CKPS=  01 => Source prdiviseur = Fosc/4/T1CKPS = 4 (utilis en PMW)
	movlw   B'00000101'
	movwf   T2CON		; Bank0

;   nc  nc  = 00 = pas utilis
;   CCP1XY  = xx = bit lsb de CCPR1L
;   CCP1M   = 0000 = module compare => mode off)
	movlw   B'00000000'
	movwf   CCP2CON

	BANK1
	movlw   .255		; Pour la sortie  50 Hz si Quartz = 3,2768 Mhz
	movwf   PR2			; Bank1
	BANK0

;   RBPU   =   0 = Rsistances de rappel sur le port B
;   INTEDG =   1 = Interruption dur front montant RB0 (pas utilis)
;   T0CS   =   0 = Source interne pour TMR0
;   TOSE   =   0 = Pas utilis
;   PSA    =   0 = Prdiviseur pour le Timer0
;   PS     = 111 = Prdiviseur pour Timer0
	BANK1				; passer en banque1
	movlw   B'01000000'
	movwf   OPTION_REG
	BANK0				; passer en banque0
	bcf     ADCON0,ADON	; Eteindre le convertisseur

	BANK1				; passer en banque1
	movlw   B'00000110' ; valeur pour mode  numrique 
	movwf   ADCON1 ; dans ADCON1
	BANK0				; passer en banque0

;   GIE    = 0 = Pas d'interruptions en global
;   PEIE   = 1 = Interruption de priphrique
;   T0IE   = 0 = Interruption autorises du timer TRM0
;   INTE   = 0 = Pas d'interruption du port PORTB
;   RBIE   = 0 = Pas d'interruption du port PORTB
;   T0IF   = 0 = Bit d'tat (dbordement TRM0)
;   INTF   = 0 = Bit d'tat (RB0 a boug)
;   RBIF   = 0 = Bit d'tat (RB4-7 a boug)
	movlw   B'01000000'
	movwf   INTCON

;   PSPIE  = 0 = Pas d'interruption du port //
;   ADIE   = 0 = Pas d'interruption conv A/D
;   RCIE   = 0 = Pas d'interruption UART recv
;   TXIE   = 0 = Pas d'interruption UART trans
;   SSPIE  = 0 = Pas d'interruption Serial port
;   CCP1IE = 0 = Pas d'interruption de CCP1
;   TMR2IE = 1 = Interruption TMR2 = PR2
;   TMR1IE = 0 = Pas d'interruption dpassement de TMR1 
	BANK1				; passer en banque1
	movlw   B'00000010'
	movwf   PIE1

	BANK0				; Passer en banque 0
	bsf INTCON,GIE		; Valider globalement les interruptions
	return
	END
